#version 440 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 n;
layout(location = 2) in vec2 t;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;

out vec3 pos;
out vec3 nor;
out vec2 tex;

void main() {
    pos = vec3(modelMatrix * vec4(position, 1.0));
    tex = t;
    mat3 norMat = transpose(inverse(mat3(modelMatrix)));
    nor = normalize(norMat * n);
    gl_Position = viewProjMatrix * modelMatrix * vec4(position.x, position.y, position.z, 1.0);
};

