#version 440 core

in VertexData{
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;

layout(location = 0) out vec4 FragColor;
//layout(location = 1) out vec4 brightness;

uniform vec3 camera_world;

uniform vec4 objCol;

uniform vec4 materialCoefficients; // x = ambient, y = diffuse, z = specular, w = specularAlpha
uniform sampler2D texture_diffuse1;


uniform struct PointLight {
	vec3 color;
	vec3 position;
	vec3 attenuation;
	float brightness;
} pointL;

const float levels = 3.0;

vec3 calcPointL(vec3 normal, vec3 fragPos, vec3 viewDir);

void main() {
	vec3 n = normalize(vert.normal_world);
	vec3 v = normalize(camera_world - vert.position_world);

	float btemp = max(dot(n,v),0.0);
	float level = floor(pointL.brightness * levels);
	btemp = level / levels;

	vec4 texColor = texture(texture_diffuse1, vert.uv).rgba;

	vec4 eitherColor = objCol + texColor;
	vec3 result = calcPointL(n, vert.position_world, v);
	FragColor = eitherColor * btemp * materialCoefficients.x; // ambient

	// add point light contribution
	color.rgb += phong(n, pointL.position - vert.position_world, v, pointL.color * eitherColor.rgb, materialCoefficients.y, pointL.color, materialCoefficients.z, materialCoefficients.w, true, pointL.attenuation, btemp);

	//do sth with brightness
	
	if (b > 1)
		brightness = vec4(color.rgb, 1.0);
	else
		brightness = vec4(0.0, 0.0, 0.0, 1.0);


	

}

vec3 calcPointL(vec3 normal, vec3 fragPos, vec3 viewDir)
{
	vec3 lightDir = (pointL.position - vert.position_world);
	//diffuse 
	float diff = max(dot(normal, lightDir), 0.0);
	//specular
	vec3 reflectDir = reflect(-lightDir, normal);
	float spec = pow(max(dot(viewDir, reflectDir), 0.0), materialCoefficients.z);
	//att
	float dis = length(pointL.position - vert.position_world);
	float att = 1.0 / (light;
}

