#version 440 core

in vec3 normal;
in vec3 fpos;

uniform vec3 objCol;

uniform vec3 lightPos;
uniform vec3 lightCol;
uniform vec3 lightInt;

uniform vec3 cameraPos;
//uniform int shiny;

out vec4 color;

vec3 ambient() {
	vec3 amb = lightInt.x * lightCol;
	return amb;
}
vec3 diffuse() {
	vec3 nor = normalize(normal); //normalized normal vec
	vec3 dir = normalize(lightPos - fpos); //normalized light direction
	float strength = max(dot(nor, dir), 0.0); //impact of diffuse light on this fragment
	vec3 dif = lightInt.y *strength * lightCol;// ((strength < 0) ? -strength : strength) * lightCol;
	return dif;
}
vec3 specular() {
	vec3 vdir = normalize(cameraPos - fpos); //normalized view direction
	vec3 ldir = normalize(lightPos - fpos); //normalized light direction
	vec3 rdir = reflect(-ldir, normal); //direction of reflected light vec
	float prespe = pow(max(dot(vdir, rdir), 0.0), 32); //16 is how shiny the obj are
	vec3 spe = lightInt.z * prespe * lightCol;
	return spe;
}

void main() {

	vec3 ambLight = ambient();
	vec3 difLight = diffuse();
	vec3 speLight = specular();

	vec3 res = (ambLight + difLight + speLight) * objCol;
	color = vec4(res, 1);
	//color = vec4(color, 1);
};

