#version 440 core

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 n;

uniform mat4 modelMatrix;
uniform mat3 normalMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;


out vec3 normal;
out vec3 fpos; //fragment pos = vertex position in world space

void main() {
	gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(position.x, position.y, position.z, 1.0);
	fpos = vec3(modelMatrix * vec4(position, 1.0));
	
	normal = normalize(n*normalMatrix);
};